// file    : dispose.cs
// compile : csc dispose.cs

using System;

public class MyClass : IDisposable {

  public MyClass(string name) {
    Console.WriteLine("creating " + name);
    this.name = name;
  }

  ~MyClass() {
    Console.WriteLine("finalizing " + name);
    Dispose();
  }

  public void Dispose() {
    Console.WriteLine("disposing " + name);
    // free resources here, and...
    // suppress further finalization...
    GC.SuppressFinalize(this);
  }

  private string name;
}

public class Go {

  public static void Main() {

    MyClass obj1 = new MyClass("obj1");

    object obj2 = new MyClass("obj2");
    if (obj2 is IDisposable)
      ((IDisposable)obj2).Dispose(); // explicitly dispose of obj2

    // garbage collection (finalization) will dispose of obj1
  }
}
