// file    : pubscount.cs
// compile : csc pubscount.cs

using System;
using System.Data;
using System.Data.SqlClient;

public class PubsCount {

  public static void Main() {

    // change the following connection string, as necessary...
    string con =
      @"server=(local)\NetSDK;database=pubs;trusted_connection=yes";

    DataSet ds = new DataSet("PubsDataSet");
    SqlDataAdapter sda;
    string sql;

    sql = "SELECT COUNT(*) AS cnt FROM authors";
    sda = new SqlDataAdapter(sql, con);
    sda.Fill(ds, "a_count");

    sql = "SELECT COUNT(*) AS cnt FROM titles";
    sda = new SqlDataAdapter(sql, con);
    sda.Fill(ds, "t_count");

    sql = "SELECT COUNT(*) AS cnt FROM publishers";
    sda = new SqlDataAdapter(sql, con);
    sda.Fill(ds, "p_count");

    int numAuthors = (int) ds.Tables["a_count"].Rows[0]["cnt"];
    int numTitles  = (int) ds.Tables["t_count"].Rows[0]["cnt"];
    int numPubs    = (int) ds.Tables["p_count"].Rows[0]["cnt"];

    Console.WriteLine(
      "There are {0} authors, {1} titles and {2} publishers.",
      numAuthors,
      numTitles,
      numPubs
    );
  }
}