// file:    base64client.cs
// compile: csc /r:istringencoder.dll base64client.cs

using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;

namespace RemoteEncoder {

  class Base64Client {

    public static void Main(string[] args) {

      ChannelServices.RegisterChannel(new HttpChannel());

      IStringEncoder objRef = (IStringEncoder)Activator.GetObject(
        typeof(IStringEncoder),
        "http://localhost/RemoteEncoder/Base64Service.rem"
      );

      string s1 = "Mary had a little lamb.";
      if (args.Length > 0) s1 = args[0];

      Console.WriteLine("original : {0}", s1);

      string s2 = objRef.Encode(s1);
      Console.WriteLine("encoded  : {0}", s2);
      Console.WriteLine("decoded  : {0}", objRef.Decode(s2));
    }
  }
}