// file:    echoclient.cs
// compile: csc /r:echoobj.dll echoclient.cs

using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using System.Threading;
using Echo;

public class EchoHandler : MarshalByRefObject {
  public void Handler(object sender, EchoEventArgs e) {
    Console.WriteLine("echo callback: {0}", e.Message);
  }
}

public class EchoClient {
  public static void Main() {

    ChannelServices.RegisterChannel(new HttpChannel(0));
    EchoObj echoObjRef = (EchoObj)Activator.GetObject(
      typeof(EchoObj),
      "http://localhost:6789/EchoObj"
    );

    EchoHandler echoHandler = new EchoHandler();
    EchoEvent echoEvent = new EchoEvent(echoHandler.Handler);
    echoObjRef.ServerEchoEvent += echoEvent;

    echoObjRef.Echo("Hello!");
    echoObjRef.Echo("Goodbye!");

    Console.WriteLine("Press Enter to end...");
    Console.ReadLine();
    Console.WriteLine("Ending...");
    Thread.Sleep(2000); // give event time to fire

    echoObjRef.ServerEchoEvent -= echoEvent;
  }
}

