// file:    echoobj.cs
// compile: csc /target:library echoobj.cs

using System;

namespace Echo {

  public delegate void EchoEvent(object sender, EchoEventArgs e);

  [Serializable]
  public class EchoEventArgs : EventArgs {
    public EchoEventArgs(string message) {
      Message = message;
    }
    public string Message;
  }

  public class EchoObj : MarshalByRefObject {

    public EchoObj() {
      Console.WriteLine("EchoObj activated...");
    }

    public event EchoEvent ServerEchoEvent;

    public void Echo(string message) {
      Console.WriteLine("received message: " + message);
      if (ServerEchoEvent != null) // ensure handler is registered
        ServerEchoEvent(this, new EchoEventArgs(message));
    }
  }
}