// file:    echoservice.cs
// compile: csc echoservice.cs

using System;
using System.Reflection;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;

public class EchoService {
  public static void Main() {

    // register a channel...
    ChannelServices.RegisterChannel(new HttpChannel(6789));

    // register HelloObj with remoting services...
    Console.WriteLine("registering EchoObj as Singleton...");

    Assembly ass = Assembly.Load("echoobj");

    RemotingConfiguration.RegisterWellKnownServiceType(
      ass.GetType("Echo.EchoObj"),        // remote object type
      "EchoObj",                          // endpoint name
      WellKnownObjectMode.Singleton);     // activation mode

    Console.WriteLine("waiting for remote calls...");
    Console.WriteLine("hit ENTER to exit...");
    Console.ReadLine();
  }
}