// file:    helloclientca3.cs
// compile: csc /r:helloservice.exe helloclientca3.cs

using System;
using System.Threading;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Lifetime;

[Serializable]
class HelloSponsor : ISponsor {
  public TimeSpan Renewal(ILease lease) {
    Console.WriteLine("sponsor invoked by lease manager...");
    return new TimeSpan(1,0,0); // another hour
  }
}


class HelloClient {

  public static void Main(string[] args) {

    Console.WriteLine("starting HTTP Hello client...");
    string configFile = "helloclient.exe.http.ca.config";
    RemotingConfiguration.Configure(configFile);
    HelloObj helloObjRef = new HelloObj();

    ILease lease = (ILease)helloObjRef.GetLifetimeService();
    lease.Register(new HelloSponsor());

    while (true) {

      Console.WriteLine(helloObjRef.Greet("Joe Bloggs"));
      Console.WriteLine(helloObjRef.Greet("Mary Bloggs"));

      Console.WriteLine("CurrentState     : " +
        lease.CurrentState);
      Console.WriteLine("CurrentLeaseTime : " +
        lease.CurrentLeaseTime);
      Console.WriteLine("InitialLeaseTime : " +
        lease.InitialLeaseTime);
      Console.WriteLine("RenewOnCallTime  : " +
        lease.RenewOnCallTime);
      Console.WriteLine();

      Thread.Sleep(350000); // sleep for more than 5 minutes
    }
  }
}