// file:      helloservice.cs
// compile:   csc helloservice.cs

// Exposes HelloObj using a remoting configuration file

using System;
using System.Runtime.Remoting;

public class HelloObj : MarshalByRefObject {

  public HelloObj() {
    Console.WriteLine("HelloObj activated...");
  }

  public string Greet(string name) {
    lock(this) { numGreet++; }
    string greeting = "Hello, " + name + "!";
    Console.WriteLine("greeting #{0}: " + greeting, numGreet);
    return greeting;
  }

  private int numGreet = 0;
}

public class HelloService {
  public static void Main(string[] args) {

    Console.WriteLine("configuring remoting...");
    string configFile = "helloservice.exe.http.singleton.config";
    if (args.Length > 0) configFile = args[0];
    Console.WriteLine("configFile=" + configFile);
    RemotingConfiguration.Configure(configFile);

    Console.WriteLine("waiting for remote calls...");
    Console.WriteLine("hit ENTER to exit...");
    Console.ReadLine();
  }
}