<%@ WebService Language="C#" Class="WebMailService" %>

// file:         WebMailService.asmx
// description:  SMTP mail Web service

using System;
using System.Web.Services;
using System.Web.Mail;

[WebService(
  Description="An SMTP mail Web service",
  Namespace="http://manning.com/dotnet/webservices"
)]

public class WebMailService : WebService {

  [WebMethod(Description="Send an SMTP mail message")]
  public string Send(string from,
                   string to,
                   string subject,
                   string cc,
                   string bcc,
                   string body) {
    try {
      MailMessage msg = new MailMessage();
      msg.From = from;
      msg.To = to;
      msg.Subject = subject;
      msg.Cc = cc;
      msg.Bcc = bcc;
      msg.Body= body;
      // set SMTP server here, if necessary
      // SmtpMail.SmtpServer = "smtp.server.com";
      SmtpMail.Send(msg);
      return "OK";
    } catch (Exception e) {
      return "ERROR : " + e.Message;
    }
  }
}