// file:    alldisco.cs
// compile: csc alldisco.cs

namespace WsdlServices {

  using System;
  using System.Xml;
  using System.Web.Services.Discovery;

  class WsdlDesc {

    public static void Main(string[] args) {

      string url;
      if (args.Length > 0)
        url = args[0];
      else
        url = "http://localhost/ws/default.disco";

      DiscoveryDocument desc = DiscoveryDocument.Read(
        new XmlTextReader(url)
      );

      Console.WriteLine("default : {0}", url);
      // get each discovery reference...
      foreach (object o in desc.References) {
        if (o is DiscoveryReference) {
          DiscoveryReference d = (DiscoveryReference) o;
          Console.WriteLine("=======================");
          // get the WSDL contract...
          discover(d.Url);
        }
      }
    }

    public static void discover(string url) {
      // get WSDL contract at this URL...
      DiscoveryDocument desc = DiscoveryDocument.Read(
        new XmlTextReader(url)
      );
      Console.WriteLine("url    : {0}", url);
      foreach (object o in desc.References) {
        if (o is ContractReference) {
          ContractReference c = (ContractReference) o;
          Console.WriteLine("Ref    : {0}", c.Ref);
          Console.WriteLine("DocRef : {0}", c.DocRef);
        }
      }
    }
  }
}