// file:    helloget.cs
// compile: csc helloget.cs

using System;
using System.Net;
using System.IO;
using System.Xml;

class HelloGet {
  public static void Main(string[] args) {

    // build URL...
    string url =
      "http://localhost/ws/helloservice1.asmx/Greet?name=";
    string argLine = String.Join(" ", args);
    if (argLine.Length > 0) url += argLine;

    // create Web request...
    WebRequest req = WebRequest.Create(new Uri(url));
    WebResponse resp = req.GetResponse();

    // get reply...
    StreamReader sr = new StreamReader(resp.GetResponseStream());
    XmlDocument xd = new XmlDocument();
    xd.LoadXml (sr.ReadToEnd());

    // display returned value...
    Console.WriteLine(xd.DocumentElement.InnerText);
  }
}