<%@ WebService Language="C#" Class="HelloService2" %>

// file:         helloservice2.asmx
// description:  hello web service with sesion state info

using System.Web.Services;

[WebService(
  Description="A stateful greeting Web service",
  Namespace="http://manning.com/dotnet/webservices"
)]

public class HelloService2 : WebService {

  public HelloService2() {
    if (newSession) {
      newSession = false; // no longer a new session
      numInst = 0;        // no instances so far
      numGreet = 0;       // no greetings yet either
    }
    numInst++;
  }

  [WebMethod(
    Description="Greet by name.",
    EnableSession= true
  )]
  public string Greet(string name) {
    numGreet++;
    if (name == "") name = "Stranger";
    return "Hello, " + name + "!";
  }

  [WebMethod(
    Description="Get number of greetings.",
    EnableSession= true
  )]
  public int NumGreet() {
    return numGreet; // return private property
  }

  [WebMethod(
    Description="Get number of times constructor invoked.",
    EnableSession= true
  )]
  public int NumInst() {
    return numInst; // return private property
  }

  private bool newSession {
    // wraps Session["newSession"] in a private property
    get {
      if (Session["newSession"] == null) return true;
      return (bool) Session["newSession"];
    }
    set {
      Session["newSession"] = value;
    }
  }

  private int numGreet {
    // wraps Session["newGreet"] in a private property
    get {
      return (int) Session["numGreet"];
    }
    set {
      Session["numGreet"] = value;
    }
  }

  private int numInst {
    // wraps Session["newInst"] in a private property
    get {
      return (int) Session["numInst"];
    }
    set {
      Session["numInst"] = value;
    }
  }
}