<%@ WebService Language="C#" Class="HelloService3" %>

// file:         helloservice3.asmx
// description:  hello web service with application state info

using System.Web.Services;

[WebService(
  Description="A stateful greeting Web service",
  Namespace="http://manning.com/dotnet/webservices"
)]

public class HelloService3 : WebService {

  [WebMethod(Description="Greet by name.")]
  public string Greet(string name) {
    numGreet++;
    if (name == "") name = "Stranger";
    return "Hello, " + name + "!";
  }

  [WebMethod(Description="Get number of greetings.")]
  public int NumGreet() {
    return numGreet;
  }

  private int numGreet {
    get {
      if (Application["numGreet"] == null) return 0;
      return (int) Application["numGreet"];
    }
    set {
      Application.Lock();
        if (Application["numGreet"] == null)
          Application["numGreet"] = 0;
        Application["numGreet"] = value;
      Application.UnLock();
    }
  }
}