// file:    stringcaseclient.cs
// compile: csc /out:stringcaseclient.exe
//              stringcaseservice.cs stringcaseclient.cs

namespace StringCase {

  using System;
  using System.Net;

  class StringCaseClient {

    public static void Main(string[] args) {

      StringCaseService scs = new StringCaseService();
      scs.CookieContainer = new CookieContainer(); // enable state

      string s = "Hello";

      Console.WriteLine("length of {0} : {1}", s, scs.GetLength(s));
      Console.WriteLine(
        "logging in mmouse:secret : {0}",
        scs.Login("mmouse", "secret")
      );
      Console.WriteLine(
        "logging in jbloggs:secret : {0}",
        scs.Login("jbloggs", "secret")
      );
      Console.WriteLine("ToUpper {0} : {1}", s, scs.ToUpper(s));
      Console.WriteLine("ToLower {0} : {1}", s, scs.ToLower(s));
      Console.WriteLine("Logging out...");
      scs.Logout();
      Console.WriteLine("Logged out.");

      // following call will raise a client-side SoapException...
      Console.WriteLine("ToLower {0} : {1}", s, scs.ToLower(s));
    }
  }
}