<%@ WebService Language="C#" Class="StringCaseService" %>

// file:         stringcaseservice.asmx
// description:  A web service to change string case.
//               Requires user to login first.

using System.Web.Services;
using System.Security;

[WebService(
  Description="A web service to change case.  Requires login.",
  Namespace="http://manning.com/dotnet/webservices"
)]

public class StringCaseService : WebService {

  [WebMethod(
    Description="Login with username and password.",
    EnableSession= true
  )]
  public bool Login(string username, string password) {
    loggedIn = false; // logout existing user, if any
    if (username == "jbloggs" && password == "secret")
      loggedIn = true;
    return loggedIn;
  }

  [WebMethod(
    Description="Logout.",
    EnableSession= true
  )]
  public void Logout() {
    loggedIn = false; // logout existing user
  }

  [WebMethod(
    Description="Uppercase a string. Must be logged in to call.",
    EnableSession= true
  )]
  public string ToUpper(string s) {
    requireLogin();
    return s.ToUpper();
  }

  [WebMethod(
    Description="Lowercase a string. Must be logged in to call.",
    EnableSession= true
  )]
  public string ToLower(string s) {
    requireLogin();
    return s.ToLower();
  }

  [WebMethod(
    Description="Return string length."
  )]
  public int GetLength(string s) {
    // login not necessary...
    return s.Length;
  }

  private void requireLogin() {
    if (!loggedIn)
      throw new SecurityException("Client not logged in!");
  }

  private bool loggedIn {
    get {
      if (Session["loggedIn"] == null) return false;
      return (bool) Session["loggedIn"];
    }
    set {
      Session["loggedIn"] = value;
    }
  }
}