// file    : uddifindbus.cs
// compile : csc /r:microsoft.uddi.sdk.dll uddifindbus.cs
// note    : make sure microsoft.uddi.sdk.dll is installed...
//           in global cache, or copy to working directory

namespace UddiTest {

  using System;
  using Microsoft.Uddi;          // from UDDI SDK
  using Microsoft.Uddi.Api;      // from UDDI SDK
  using Microsoft.Uddi.Business; // from UDDI SDK

  public class FindBus {

    public static void Main(string[] args) {

      Inquire.Url = "http://test.uddi.microsoft.com/inquire";

      FindBusiness fb = new FindBusiness();
      if (args.Length == 0)
        fb.Name = "Joe";
      else
        fb.Name = args[0];
      Console.WriteLine("searching for {0}...", fb.Name);

      fb.MaxRows = 5; // no more than 5 businesses
      BusinessList bl = fb.Send(); // get the list
      foreach(BusinessInfo bi in bl.BusinessInfos) {
        Console.WriteLine("================================");
        Console.WriteLine(bi.Name); // the business name
        foreach(Description d in bi.Descriptions) {
          Console.WriteLine(d.Text); // the business description
        }
      }

      Console.WriteLine("Done!");
    }
  }
}