// file:    wsdldesc.cs
// compile: csc wsdldesc.cs

namespace WsdlServices {

  using System;
  using System.Xml;
  using System.Web.Services.Description;

  class WsdlDesc {

    public static void Main(string[] args) {

      string url;
      if (args.Length > 0)
        url = args[0];
      else
        url = "http://localhost/ws/helloservice1.asmx?WSDL";

      ServiceDescription desc = ServiceDescription.Read(
        new XmlTextReader(url)
      );

      Console.WriteLine("url          : {0}", url);
      foreach (Service s in desc.Services) {
        Console.WriteLine("service name : {0}", s.Name);
        Console.WriteLine("description  : {0}", s.Documentation);
        Console.Write("ports        : ");
        foreach (Port p in s.Ports) {
          Console.Write("{0} ", p.Name);
        }
        Console.WriteLine();
      }
    }
  }
}