// file    : secondform.cs
// compile : csc /t:winexe secondform.cs

using System;
using System.Windows.Forms;

namespace MyForms {

  public class SecondForm : Form {

    public static void Main() {
      // create form and start Windows message loop...
      Application.Run(new SecondForm());
    }

    public SecondForm() {

      // set up the form...
      Width = 250;                // form width
      Height = 100;               // form height
      CenterToScreen();           // display form center screen

      // set up the button...
      Button b = new Button();    // create button
      b.Text = "Show Time";       // set button text
      b.Width = 100;              // set button width
      b.Top = 20;                 // set top coordinate
      b.Left = 30;                // set left coordinate

      // set up click event handler...
      b.Click += new EventHandler(clickHandler);

      // add the control to the form...
      Controls.Add(b);
    }

    private void clickHandler(object sender, EventArgs e) {
      // user has clicked button, so...
      // display current time...
      Text = String.Format("Click Time: {0:T}", DateTime.Now);
    }
  }
}
