// file    : timerform.cs
// compile : csc /t:winexe timerform.cs

using System;
using System.Windows.Forms;
using System.ComponentModel;

namespace MyForms {

  public class TimerForm : Form {

    public static void Main() {
      // create form and start Windows message loop...
      Application.Run(new TimerForm());
    }

    public TimerForm() {

      // set up form...
      Text = "TimerForm"; // title bar text
      Width = 400;            // form width
      Height = 100;           // form height
      CenterToScreen();       // display center screen

      // create container for components...
      components = new Container();

      // create timer and add to container...
      timer = new Timer(components);

      // set the clock...
      timer.Interval = 1000; // tick every second

      // register the tick handler...
      timer.Tick += new EventHandler(timerHandler);

      // start the clock...
      timer.Start();

      // create tooltip and add to container...
      tooltip = new ToolTip(components);

      // set tooltip target and text...
      tooltip.SetToolTip(this, "This is a Windows Form.");
    }

    private void timerHandler(object o, EventArgs e) {
      Text = String.Format("Time: {0:T}", DateTime.Now);  // tick
    }

    protected override void Dispose(bool disposing) {
      if (disposing)
        if (components != null)
          components.Dispose(); // dispose of components...
      base.Dispose(disposing);
    }

    private Timer timer;            // a component
    private ToolTip tooltip;        // also a component
    private Container components;   // contains components
  }
}
