<!-- ageform.aspx -->
<%@ Page Language="C#" Debug="true" %>

<script runat="server">
  private void ageHandler(object sender, EventArgs e) {
    if (IsValid)
      ageLabel.Text = "You are " + ageTextBox.Text + " years old.";
    else
      ageLabel.Text = "Please Enter Your Age.";
  }
</script>

<html><head><title>Validating a User's Age</title></head><body>
  <form runat='server'>

    <h1>Validating a User's Age</h1>
    <asp:label text="Age : " runat="server"/>
    <asp:textbox
      id="ageTextBox"
      columns="3"
      maxLength = "3"
      runat="server"/>
    <asp:button
      id="submitButton"
      text="Submit"
      onClick="ageHandler"
      runat="server"/>
    <p>
      <asp:label
        id="ageLabel"
        text="Please Enter Your Age."
        runat="server"/>
    </p>

    <!-- require an entry...  -->
    <asp:requiredFieldValidator
      controlToValidate="ageTextBox"
      errorMessage="Age required"
      enableClientScript="true"
      display="static"
      runat=server />

    <br/>

    <!-- must be an integer...  -->
    <asp:regularExpressionValidator
      controlToValidate="ageTextBox"
      errorMessage="Age must be an integer"
      enableClientScript="true"
      display="static"
      validationExpression="^\d{1,3}$"
      runat="server" />

    <br/>

    <!-- must be aged between 1 and 120 years...  -->
    <asp:rangeValidator
      controlToValidate="ageTextBox"
      errorMessage="Age must be between 1 and 120 years"
      enableClientScript="true"
      display="static"
      type="Integer"
      minimumValue="1"
      maximumValue="120"
      runat="server" />

    <hr/>

  </form>
</body></html>
