// file    : custhttpmodules.cs
// compile : csc /t:library custhttpmodules.cs

using System;
using System.Web;
using System.Web.SessionState;

namespace CustHttpModules {

  public class RequestCounterModule : IHttpModule {

    public void Init(HttpApplication ha) {
      ha.AcquireRequestState += new EventHandler(gotState);
    }

    public void Dispose() {
      // perform any necessary cleanup here
    }

    private void gotState(object sender, EventArgs e) {

      HttpApplication ha = (HttpApplication)sender;
      HttpSessionState s = ha.Session;

      if (s["numRequests"] == null) {
        s["numRequests"] = 1;
      } else {
        int numRequests = (int)s["numRequests"];
        s["numRequests"] = ++numRequests;
      }
    }
  }
}
