// file: PokerQueue.cs
// compile: csc /target:library PokerQueue.cs

using System;
using System.Messaging;

namespace Poker {

  public class PokMsg {
    public string QID;
    public string Command;
    public string Hand;
    public string HoldCards;
    public string Title;
    public int Score;
  }

  public class PokerQueue {

    public PokerQueue (string qPath) {
      QPath = @".\Private$\" + qPath;
      // create and instantiate queue...
      if (!MessageQueue.Exists(QPath)) MessageQueue.Create(QPath);
      q = new MessageQueue(QPath);

      // format queue for storing the PokMsg type...
      // from the pokerqueue.dll assembly
      q.Formatter =
        new XmlMessageFormatter(
          new string[]{"Poker.PokMsg, pokerqueue"}
        );
    }

    public void Send(PokMsg msg) {
      q.Send(msg); // send a PokMsg object
    }

    public PokMsg Receive() {
      return (PokMsg)q.Receive().Body; // receive a PokMsg object
    }

    public void Kill() {
      q.Purge(); // zap messages (not strictly necessary)
      MessageQueue.Delete(QPath); // delete the queue
    }

    private string QPath;
    private MessageQueue q;
  }
}