//  file:          QuePok.cs
//  description:   a MSMQ poker machine client
//  compile:       csc /r:PokerQueue.dll QuePok.cs

namespace Poker {

  using System;

  class QuePok {

    public static void Main(string[] args) {
      new QuePok(); // start game
    }

    public QuePok() {
      inQPath = "PokClient_" + new System.Random().Next(1, 1000000);
      inQ = new PokerQueue(inQPath);
      outQ = new PokerQueue("PokerServer");
      pokMsg = new PokMsg();
      pokMsg.QID = inQPath;
      Console.WriteLine("A message queue-based poker game...");
      while (!gameOver) nextGame(); // play
    }

    private void nextGame() {

      pokMsg.Command = "DEAL";
      outQ.Send(pokMsg);
      pokMsg = inQ.Receive();

      Console.WriteLine(pokMsg.Hand); // display it
      Console.Write(
        "Enter card numbers (1 to 5) to hold, or Q to exit: "
      );
      string command =
        pokMsg.HoldCards =
          Console.ReadLine().Trim().ToUpper();

      if (command.Equals("Q")) {
        inQ.Kill();
        gameOver = true;
        return;
      }

      pokMsg.Command = "DRAW";
      outQ.Send(pokMsg);
      pokMsg = inQ.Receive();

      Console.WriteLine(pokMsg.Hand); // the hand
      Console.WriteLine(pokMsg.Title); // the title
      Console.WriteLine("Score = {0}\n", pokMsg.Score); // the score
    }

    private bool gameOver = false;
    private string inQPath;
    private PokerQueue inQ;
    private PokerQueue outQ;
    private PokMsg pokMsg;
  }
}