// file:    QuePokService.cs
// compile: csc /r:PokerQueue.dll;poker.dll QuePokService.cs

using System;

namespace Poker {

  public class QuePokService {

    public static void Main () {

      PokerQueue inQ = new PokerQueue("PokerServer");
      SimpleMachine machine = new SimpleMachine();

      Console.WriteLine("waiting for messages...");
      while(true) {

        PokMsg pokMsg = inQ.Receive();
        Console.WriteLine(
          "received : {0} : {1}",
          pokMsg.QID, pokMsg.Command
        );

        PokerQueue outQ = new PokerQueue(pokMsg.QID);

        if (pokMsg.Command.Equals("DEAL")) {
          pokMsg.Hand = machine.Deal().Text;
          outQ.Send(pokMsg);
          continue;
        }

        if (pokMsg.Command.Equals("DRAW")) {
          Hand h = machine.Draw(pokMsg.Hand, pokMsg.HoldCards);
          pokMsg.Hand = h.Text;
          pokMsg.Title = h.Title;
          pokMsg.Score = h.Score;
          outQ.Send(pokMsg);
        }
      }
    }
  }
}