// file    : simpok.cs
// compile : csc /r:poker.dll simpok.cs

using System;
using Poker;

class SimPok {

  public static void Main() {
    new SimPok(); // start game
  }

  public SimPok() {
    Console.WriteLine("A simple poker game...");
    Console.WriteLine("Hit Ctrl-c at any time to abort.\n");
    machine = new SimpleMachine(); // create poker machine
    while (true) nextGame(); // play
  }

  private void nextGame() {

    Hand dealHand = machine.Deal(); // deal hand
    Console.WriteLine("{0}", dealHand.Text); // display it

    // invite player to hold cards...
    Console.Write("Enter card numbers (1 to 5) to hold: ");
    string holdCards = Console.ReadLine();

    // draw replacement cards...
    Hand drawHand = machine.Draw(dealHand, holdCards);
    Console.WriteLine(drawHand.Text);
    Console.WriteLine(drawHand.Title);
    Console.WriteLine("Score = {0}\n", drawHand.Score);
  }

  private SimpleMachine machine;
}