//  file:          SvcPok.cs
//  description:   a client for the Windows service poker machine
//  compile:       csc /r:SvcPokService.exe;poker.dll SvcPok.cs

namespace Poker {

  using System;
  using System.Runtime.Remoting;
  using System.Runtime.Remoting.Channels;
  using System.Runtime.Remoting.Channels.Http;

  class SvcPok {

    public static void Main(string[] args) {
      Console.WriteLine("starting HTTP SvcPok client...");
      ChannelServices.RegisterChannel(new HttpChannel());
      string url = "http://localhost:6789/SvcPokService";
      SvcPokService service = (SvcPokService)Activator.GetObject(
          typeof(Poker.SvcPokService),
          url
        );
      new SvcPok(service); // start game
    }

    public SvcPok(SvcPokService service) {
      this.service = service;
      Console.WriteLine("A Windows service-based poker game...");
      Console.WriteLine("Hit Ctrl-c at any time to abort.\n");
      while (true) nextGame(); // play
    }

    private void nextGame() {

      string dealHand = service.Deal(); // deal hand
      Console.WriteLine(dealHand); // display it
      Console.Write("Enter card numbers (1 to 5) to hold: ");
      string holdCards = Console.ReadLine();

      GameResult res = service.Draw(dealHand, holdCards);
      Console.WriteLine(res.Hand);
      Console.WriteLine(res.Title);
      Console.WriteLine("Score = {0}\n", res.Score);
    }

    private SvcPokService service = null;
  }
}