// file    : WSPok.cs
// compile : csc /out:WSPok.exe WSPokService.cs WSPok.cs

namespace Poker {

  using System;

  class WSPok {

    public static void Main() {
      new WSPok(); // start game
    }

    public WSPok() {
      Console.WriteLine("A WebService-based poker game...");
      Console.WriteLine("Hit Ctrl-c at any time to abort.\n");
      service = new WSPokService(); // create poker service
      while (true) nextGame(); // play
    }

    private void nextGame() {

      string dealHand = service.Deal(); // deal hand
      Console.WriteLine(dealHand); // display it
      Console.Write("Enter card numbers (1 to 5) to hold: ");
      string holdCards = Console.ReadLine();

      // draw replacement cards...
      GameResult res = service.Draw(dealHand, holdCards);
      Console.WriteLine(res.Hand);
      Console.WriteLine(res.Title);
      Console.WriteLine("Score = {0}\n", res.Score);
    }

    private WSPokService service;
  }
}