<%@ WebService Language="C#" Class="WSPokService" %>

// file:         WSPokService.asmx
// description:  poker machine web service

using System.Web.Services;
using Poker;

[WebService(
  Description="A Poker Web service",
  Namespace="http://manning.com/dotnet/webservices"
)]

public class WSPokService : WebService {

  [WebMethod(Description="Deal a poker hand.")]
  public string Deal() {
    return new SimpleMachine().Deal().Text;
  }

  [WebMethod(Description="Draw cards.")]
  public GameResult Draw(string oldHand, string holdCards) {
    GameResult g = new GameResult();
    Hand h = new SimpleMachine().Draw(oldHand, holdCards);
    g.Hand = h.Text;
    g.Score = h.Score;
    g.Title = h.Title;
    return g;
  }
}

public struct GameResult {
  public string Hand;
  public int Score;
  public string Title;
}