// file : WebPok.cs
// This is the codebehind logic for WebPok.aspx.

namespace Poker {

  using System;
  using System.Web.UI;
  using System.Web.UI.WebControls;

  public class WebPok : System.Web.UI.Page {

    protected void dealDrawHandler(object Source, EventArgs e) {
      Hand h;
      if (dealDrawButton.Text == "DEAL") {

        // deal...
        h = new SimpleMachine().Deal();
        handLabel.Text = h.Text;
        card1.ImageUrl="images/" + h.CardName(1) + ".gif";
        card2.ImageUrl="images/" + h.CardName(2) + ".gif";
        card3.ImageUrl="images/" + h.CardName(3) + ".gif";
        card4.ImageUrl="images/" + h.CardName(4) + ".gif";
        card5.ImageUrl="images/" + h.CardName(5) + ".gif";
        enableCheckBoxes(true);
        clearCheckBoxes();
        dealDrawButton.Text = "DRAW";
        messageLabel.Text = "Hold Cards and Click DRAW";
        return;
      }

      // draw...
      string holdCards = "";
      if (hold1.Checked) holdCards += "1";
      if (hold2.Checked) holdCards += "2";
      if (hold3.Checked) holdCards += "3";
      if (hold4.Checked) holdCards += "4";
      if (hold5.Checked) holdCards += "5";
      h = new SimpleMachine().Draw(handLabel.Text, holdCards);
      card1.ImageUrl="images/" + h.CardName(1) + ".gif";
      card2.ImageUrl="images/" + h.CardName(2) + ".gif";
      card3.ImageUrl="images/" + h.CardName(3) + ".gif";
      card4.ImageUrl="images/" + h.CardName(4) + ".gif";
      card5.ImageUrl="images/" + h.CardName(5) + ".gif";
      dealDrawButton.Text = "DEAL";
      enableCheckBoxes(false);
      messageLabel.Text = h.Title + " (Scores " + h.Score + ")";
    }

    private void enableCheckBoxes(bool flag) {
      hold1.Enabled = hold2.Enabled = hold3.Enabled =
        hold4.Enabled = hold5.Enabled = flag;
    }

    private void clearCheckBoxes() {
      hold1.Checked = hold2.Checked = hold3.Checked =
        hold4.Checked = hold5.Checked = false;
    }

    protected Button dealDrawButton;
    protected Label handLabel,messageLabel;
    protected Image card1, card2, card3, card4, card5;
    protected CheckBox hold1, hold2, hold3, hold4, hold5;
  }
}
