using System;
namespace Poker {
  public class Bet {
    public Bet(int bet, int credits, int minBet, int maxBet) {
      if (credits < minBet) {
        Message =
          "You don't have enough credits to bet...  Game over!";
        Amount = 0;
        return;
      }
      if (bet < minBet) {
        Message = String.Format(
          "You must bet the minimum... betting {0}.", minBet);
        Amount = minBet;
        Credits = credits - Amount;
        return;
      }
      maxBet = credits < maxBet ? credits : maxBet;
      if (bet > maxBet) {
        Message = String.Format(
          "You can only bet {0}... betting {0}.", maxBet);
        Amount = maxBet;
        Credits = credits - Amount;
        return;
      }
      Message = "";
      Amount = bet;
      Credits = credits - Amount;
    }
    public readonly int Amount;
    public readonly int Credits;
    public readonly string Message;
  }
}