' file    : ConPok.vb
' compile : vbc /r:poker.dll conpok.vb

Option Strict On    ' no implicit type conversions
Option Explicit On  ' variables must be declared

Imports System
Imports Microsoft.VisualBasic
Imports Microsoft.VisualBasic.Constants
Imports System.Collections
Imports System.Text
Imports Poker

Public Class ConPok

  Private _machine As Machine
  Private _minBet As Integer
  Private _maxBet As Integer
  Private _uiCredits As Integer
  Private _uiBet As Integer

  Public Sub New()

    greeting()

    _machine = Machine.Instance
    _uiBet = _machine.MinBet
    _minBet = _machine.MinBet
    _maxBet = _machine.MaxBet
    _uiCredits = _machine.StartCredits

    ' play until our opponent is wiped out!
    While _uiCredits >= _minBet
      nextGame()
    End While
    Console.WriteLine("*** Loser! ***  :-)")
  End Sub

  Private Sub greeting()
    Console.WriteLine( _
      vbCrLf + "Welcome to the Console Version of Video Poker.")
    Console.WriteLine( _
      "Cards are numbered 1 to 5 from left to right.")
    Console.WriteLine( _
      "To hold cards, enter card numbers and hit enter.")
    Console.WriteLine( _
      "Hit Ctrl-c at any time to abort." + vbCrLf)
  End Sub


  Private Sub nextGame()

    Console.WriteLine("Credits Remaining : {0}", _uiCredits)
    Console.Write("Enter amount of bet : ")

    Dim reply As String = Console.ReadLine()
    Dim newBet As Integer
    Try
      newBet = Int32.Parse(reply)
    Catch e As Exception
      ' use previous bet...
      newBet = _uiBet
    End Try

    Dim bet As Bet = New Bet(newBet, _uiCredits, _minBet, _maxBet)
    _uiBet = bet.Amount
    _uiCredits = bet.Credits

    If bet.Message.Equals("") Then
      Console.WriteLine("Betting {0}...", _uiBet)
    else
      Console.WriteLine(bet.Message + Chr(7)) ' ring bell
    End If

    Dim dealHand As Hand = _machine.Deal() ' deal
    Console.WriteLine("{0}", dealHand)

    Console.Write("Enter card numbers (1 to 5) to hold: ")
    Dim holdCards As String = Console.ReadLine()

    Dim drawHand As Hand = _
      _machine.Draw(dealHand.ToString(), holdCards, _uiBet)

    Dim uiWin As Integer = drawHand.Score * _uiBet
    _uiCredits = _uiCredits + uiWin
    Dim uiMsg As String = _
      drawHand.ToString() & " - " & drawHand.Title & " " & _
      "(Score=" & drawHand.Score & ", " & _
      "Bet=" & _uiBet & ", " & "Win=" & uiWin & ")"

    Console.WriteLine(uiMsg)

    Console.WriteLine(_machine.Stats)
  End Sub

End Class

' action starts here...
Public Class Go
  Public Shared Sub Main()
    Dim cp As ConPok = New ConPok()
  End Sub
End Class
