// file        : simpok.js
// compile     : jsc /r:poker.dll simpok.js
// description : a JavaScript console program to play simple poker version

import System;
import Poker;

Console.WriteLine("A simple JavaScript .NET poker game...");
Console.WriteLine("Hit Ctrl-c at any time to abort.");
Console.WriteLine();

// create poker machine...
var machine : SimpleMachine = new SimpleMachine;

// play poker...
while (true) {

  var dealHand : Hand = machine.Deal(); // deal hand
  Console.WriteLine(dealHand.Text); // display it

  // invite player to hold cards...
  Console.Write("Enter card numbers (1 to 5) to hold: ");
  var holdCards : String = Console.ReadLine();

  // draw replacement cards...
  var drawHand : Hand = machine.Draw(dealHand, holdCards);
  Console.WriteLine(drawHand.Text);
  Console.WriteLine(drawHand.Title);
  Console.WriteLine("Score = {0}", drawHand.Score);
  Console.WriteLine();
}
