' file        : simpok.vb
' compile     : vbc /r:poker.dll simpok.vb
' description : a Visual Basic .NET console program to play simple poker version

Option Strict On    ' no implicit type conversions
Option Explicit On  ' variables must be declared

Imports System
Imports Poker

Public Class SimPok

  Public Shared Sub Main()
    Dim s As SimPok = New SimPok() ' start game
  End Sub

  Public Sub New()
    Console.WriteLine("A simple poker game...")
    Console.WriteLine("Hit Ctrl-c at any time to abort.")
    Console.WriteLine()
    machine = New SimpleMachine() ' create poker machine
    While True
      nextGame() ' play
    End While
  End Sub

  Private Sub nextGame()

    Dim dealHand As Hand = machine.Deal() ' deal hand
    Console.WriteLine(dealHand.Text) ' display it

    ' invite player to hold cards...
    Console.Write("Enter card numbers (1 to 5) to hold: ")
    Dim holdCards As String = Console.ReadLine()

    ' draw replacement cards...
    Dim drawHand As Hand = machine.Draw(dealHand, holdCards)
    Console.WriteLine(drawHand.Text)
    Console.WriteLine(drawHand.Title)
    Console.WriteLine("Score = {0}", drawHand.Score)
    Console.WriteLine()
  End Sub

  Private machine As SimpleMachine
End Class