Option Strict On    ' no implicit type conversions
Option Explicit On  ' variables must be declared

Namespace Poker

  Public Class Bet

    Public Sub New( bet As Integer, _
                    creds As Integer, _
                    minBet As Integer, _
                    maxBet As Integer)

      If creds < minBet Then
        Message = _
          "You don't have enough credits to bet...  Game over!"
        Amount = 0
        Return
      End If

      If bet < minBet Then
        Message = String.Format( _
          "You must bet the minimum... betting {0}.", minBet)
        Amount = minBet
        Credits = creds - Amount
        Return
      End If

      If creds < maxBet Then maxBet = creds

      If bet > maxBet Then
        Message = String.Format( _
          "You can only bet {0}... betting {0}.", maxBet)
        Amount = maxBet
        Credits = creds - Amount
        Return
      End If

      Message = ""
      Amount = bet
      Credits = creds - Amount
    End Sub

    Public ReadOnly Amount As Integer
    Public ReadOnly Credits As Integer
    Public ReadOnly Message As String

  End Class
End Namespace
