Option Strict On    ' no implicit type conversions
Option Explicit On  ' variables must be declared

Imports System
Imports System.Reflection
<Assembly:AssemblyVersion("1.0.0.0")>

Namespace Poker

  Friend Class Card

    Public Sub New()
      Me.New(New Random())
    End Sub

    Public Sub New(r As Random)
      Number = r.Next(2, 15)
      Suit = r.Next(1, 5)
      Name = numberArray(Number - 2) & suitArray(Suit - 1)
    End Sub

    Public Sub New(name As String)
      Dim n As String = name.Substring(0, 1)
      Dim s As String = name.Substring(1, 1)
      Number = numberString.IndexOf(n) + 2
      Suit = suitString.IndexOf(s) + 1
      Me.Name = name
    End Sub

    Public Readonly Dim Number As Integer
    Public Readonly Dim Suit As Integer
    Public Readonly Name As String ' Dim keyword can be omitted

    Overrides Public Function ToString() As String
      Return Name
    End Function

    Overloads Overrides Public _
      Function Equals(ByVal obj As Object) As Boolean
        Try
          Dim c as Card = CType(obj, Card)
          Return c.Number = Number And c.Suit = Suit
        Catch e As Exception
          Return False
        End Try
    End Function

    Overrides Public Function GetHashCode() As Integer
      Return (Suit * 2 * 2 * 2 * 2) + Number
    End Function

    ' Private fields...
    Private Shared numberArray() As String _
      = New String() _
        {"2","3","4","5","6","7","8","9","T","J","Q","K","A"}
    Private Shared suitArray() As String _
      = New String() {"C","D","H","S"}
    Private Shared numberString As String = "23456789TJQKA"
    Private Shared suitString As String = "CDHS"

  End Class
End Namespace
